diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java
index 17d9258b2..be7dd11e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java
@@ -3,13 +3,13 @@ package net.minecraft.client.render.shader;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.RenderBuffer;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.ItemStack;
@@ -73,12 +73,12 @@ public final class ShaderHelper {
         shader.uniformFloat("width", minecraft.gameWindow.getWidthPixels());
         shader.uniformFloat("height", minecraft.gameWindow.getHeightPixels());
         shader.uniformFloat("frameTimeCounter", frameTimeCounter);
-        shader.uniformFloat("gamma", minecraft.gameSettings.gamma.value);
-        shader.uniformFloat("fxaa", minecraft.gameSettings.fxaa.value);
-        shader.uniformFloat("heatHaze", minecraft.gameSettings.heatHaze.value ? minecraft.ppm.lerped.heatHaze : 0.0f);
-        shader.uniformInt("bloom", minecraft.gameSettings.bloom.value);
+        shader.uniformFloat("gamma", GameSettings.GAMMA.value);
+        shader.uniformFloat("fxaa", GameSettings.FXAA.value);
+        shader.uniformFloat("heatHaze", GameSettings.HEAT_HAZE.value ? minecraft.ppm.lerped.heatHaze : 0.0f);
+        shader.uniformInt("bloom", GameSettings.BLOOM.value);
         shader.uniformInt("dimension", minecraft.currentWorld != null && minecraft.currentWorld.dimension != null ? minecraft.currentWorld.dimension.id : 0);
-        shader.uniformInt("cbCorrectionMode", minecraft.gameSettings.colorblindnessFix.value.ordinal());
+        shader.uniformInt("cbCorrectionMode", GameSettings.COLORBLINDNESS_FIX.value.ordinal());
 
         ItemStack helmet = minecraft.thePlayer == null ? null : minecraft.thePlayer.getItemInArmorSlot(HumanArmorShape.HEAD);
         shader.uniformInt("shaderEffect", helmet != null && helmet.itemID == Blocks.PUMPKIN_REDSTONE.id() ? 1 : 0);
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index 397d2cc2a..d40b63b47 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -1,21 +1,22 @@
 package net.minecraft.client.render.shader;
 
-import java.io.File;
-
 import com.mojang.logging.LogUtils;
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.renderer.Shaders;
-import net.minecraft.core.block.material.Materials;
-
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.CloudQuality;
 import net.minecraft.client.render.FrameBuffer;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.Renderer;
-import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.camera.CameraUtil;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.core.block.material.Materials;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
+import java.io.File;
+
 public class ShadersRenderer implements Renderer {
     private static final Logger LOGGER = LogUtils.getLogger();
     public Minecraft mc;
@@ -138,7 +139,7 @@ public class ShadersRenderer implements Renderer {
 
     @Override
     public void beginRenderClouds(float partialTicks) {
-        if (this.mc.gameSettings.clouds.value && this.mc.gameSettings.fancyGraphics.value == 1 && Shaders.CLOUDS.isEnabled()) {
+        if (GameSettings.CLOUDS.value && GameSettings.CLOUD_QUALITY.value == CloudQuality.FANCY && Shaders.CLOUDS.isEnabled()) {
             OpenGLHelper.checkError("pre setup clouds");
 
             // Alpha test is implemented in the shader because regular alpha test removes some pixels at the edge
@@ -175,7 +176,7 @@ public class ShadersRenderer implements Renderer {
     }
 
     public void setupFramebuffer() {
-        double renderScale = (float) this.mc.gameSettings.renderScale.value.scale;
+        double renderScale = (float) GameSettings.RENDER_SCALE.value.scale;
 
         int scaledWidth = (int) (renderScale * this.mc.gameWindow.getWidthPixels());
         int scaledHeight = (int) (renderScale * this.mc.gameWindow.getHeightPixels());
@@ -195,7 +196,7 @@ public class ShadersRenderer implements Renderer {
             this.renderWidth = scaledWidth;
             this.renderHeight = scaledHeight;
 
-            boolean filtering = this.mc.gameSettings.renderScale.value.useLinearFiltering;
+            boolean filtering = GameSettings.RENDER_SCALE.value.useLinearFiltering;
             int filterMode = filtering ? GL41.GL_LINEAR : GL41.GL_NEAREST;
 
             LOGGER.info("Display: {} x {}, Render: {} x {}", this.fbWidth, this.fbHeight, this.renderWidth, this.renderHeight);
@@ -278,7 +279,7 @@ public class ShadersRenderer implements Renderer {
     }
 
     public ShaderProvider getShader() {
-        String override = this.mc.gameSettings.shaderOverride.value;
+        String override = GameSettings.SHADER_OVERRIDE.value;
         if (!override.isEmpty()) {
             return new ShaderProviderExternal(new File(override));
         } else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
index caf724961..084b46697 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
@@ -1,19 +1,19 @@
 package net.minecraft.client.render.terrain;
 
-import java.util.Arrays;
-import java.util.List;
-
-import net.minecraft.client.render.renderer.GLRenderer;
-import net.minecraft.client.render.renderer.Shaders;
-import net.minecraft.core.block.entity.TileEntity;
-
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
 import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
+import java.util.Arrays;
+import java.util.List;
+
 public class TerrainRendererMultiDraw extends TerrainRenderer {
 
     public final int VERTEX_BUFFER_INITIAL_CAPACITY = 67108864;
@@ -134,15 +134,13 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
 
         this.terrainVertexConfig.enable(this.vertexBuffer.getVao(), this.vertexBuffer.getVbo());
 
-        boolean fancy = this.mc.gameSettings.fancyGraphics.value != 0;
-
-        if (fancy) {
+        if (GameSettings.TRANSPARENCY_DEPTH_CHECK.value) {
             GLRenderer.setColorMask(false, false, false, false);
         }
 
         renderAllLists(1);
 
-        if (fancy) {
+        if (GameSettings.TRANSPARENCY_DEPTH_CHECK.value) {
             GLRenderer.setColorMask(true, true, true, true);
             if (this.drawCalls[1] > 0) {
                 renderAllLists(1);
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
index c6c90092a..1be432f97 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
@@ -7,7 +7,7 @@ import static org.lwjgl.opengl.GL41.GL_TEXTURE_MAX_LEVEL;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.MipmapType;
 import net.minecraft.client.render.texture.meta.TextureProperties;
 import net.minecraft.client.util.helper.Buffer;
@@ -138,8 +138,7 @@ public class Texture {
 		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 
 		if(mipmap) {
-			Minecraft mc = Minecraft.getMinecraft();
-			generateMipmaps(buffer, img, mc.gameSettings.mipmapLevels.value, mc.gameSettings.mipmapType.value == MipmapType.SMOOTH);
+			generateMipmaps(buffer, img, GameSettings.MIPMAP_LEVELS.value, GameSettings.MIPMAP_TYPE.value == MipmapType.SMOOTH);
 		}
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
index 5e2d5fff6..d5c89844f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
@@ -9,7 +9,6 @@ import java.util.List;
 import java.util.Map;
 
 import com.mojang.logging.LogUtils;
-import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
@@ -244,15 +243,6 @@ public class AtlasStitcher {
         return image;
     }
 
-    public int[] getIconData(@NotNull String layer, @NotNull IconCoordinate coordinate, int[] dest) {
-        BufferedImage img = this.layerImageMap.get(layer);
-        if (img != null) {
-            assert dest.length >= coordinate.getArea();
-            img.getRGB(coordinate.iconX, coordinate.iconY, coordinate.width, coordinate.height, dest, 0, coordinate.width);
-        }
-        return dest;
-    }
-
     public void bind() {
         this.colorTexture.bind();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
index f4f856b27..9b4fbe3ef 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
@@ -14,6 +14,7 @@ import java.util.stream.Stream;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.holiday.Holidays;
+import net.minecraft.client.option.GameSettings;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
@@ -47,7 +48,7 @@ public abstract class TexturePack {
 
 	public @Nullable InputStream getResourceAsStream(String s)
 	{
-		if (Holidays.getCurrentThemedHoliday() != null && Minecraft.getMinecraft().gameSettings.enableHolidayTextures.value) {
+		if (Holidays.getCurrentThemedHoliday() != null && GameSettings.ENABLE_HOLIDAY_TEXTURES.value) {
 			assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
 			String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + s).replace("//", "/");
 			InputStream holidayStream = TexturePack.class.getResourceAsStream(holidayPath);
@@ -101,7 +102,7 @@ public abstract class TexturePack {
 		}
 		catch (Exception e)
 		{
-            LOGGER.error("Exception while loading all files in directory '{}' at '{}'!", directory, packId, e);
+            LOGGER.error("Exception while loading all files in directory '{}' at '{}'!", directory, this.packId, e);
 		}
 
 		return paths.toArray(new String[0]);
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
index 276f0eb0c..8d76648dc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
@@ -16,298 +16,250 @@ import java.util.zip.ZipFile;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.holiday.Holidays;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.TextureBuffered;
 import net.minecraft.client.render.texturepack.Manifest.ManifestException;
 import org.slf4j.Logger;
 
 import javax.imageio.ImageIO;
 
-public class TexturePackCustom extends TexturePack
-{
-	private static final Logger LOGGER = LogUtils.getLogger();
-	private TextureBuffered thumbnailImage;
-	private BufferedImage thumbnailBuffer;
-	public final File file;
-	private ZipFile zipFile;
-	public boolean debug = false;
+public class TexturePackCustom extends TexturePack {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private TextureBuffered thumbnailImage;
+    private BufferedImage thumbnailBuffer;
+    public final File file;
+    private ZipFile zipFile;
+    public boolean debug = false;
 
-    public TexturePackCustom(File file)
-    {
-        thumbnailImage = null;
-        fileName = file.getName();
+    public TexturePackCustom(File file) {
+        this.thumbnailImage = null;
+        this.fileName = file.getName();
         this.file = file;
     }
 
-	public void setDebug() {
-		debug = true;
-	}
+    public void setDebug() {
+        this.debug = true;
+    }
 
-	@Override
-	public void readTexturePackManifest()
-		throws IOException {
-		if (file.isFile()) {
-			// Texture pack is zip file
-			ZipEntry manifestEntry = zipFile.getEntry("manifest.json");
-			if(manifestEntry != null) {
-				// manifest.json exists
+    @Override
+    public void readTexturePackManifest()
+        throws IOException {
+        if (this.file.isFile()) {
+            // Texture pack is zip file
+            ZipEntry manifestEntry = this.zipFile.getEntry("manifest.json");
+            if (manifestEntry != null) {
+                // manifest.json exists
 
-                try (InputStream in = zipFile.getInputStream(manifestEntry)) {
+                try (InputStream in = this.zipFile.getInputStream(manifestEntry)) {
                     readManifest(in);
                 } catch (Exception e) {
-                    LOGGER.error("Exception reading manifest for '{}'!", packId, e);
+                    LOGGER.error("Exception reading manifest for '{}'!", this.packId, e);
                 }
-			}else {
-				// Assume it's an old texture pack
+            } else {
+                // Assume it's an old texture pack
 
-				String name = file.getName();
-				String line1 = "";
-				String line2 = "";
-				
-				ZipEntry packTxtEntry = zipFile.getEntry("pack.txt");
-				if(packTxtEntry != null) {
-                    try (InputStream in = zipFile.getInputStream(packTxtEntry); BufferedReader br = new BufferedReader(new InputStreamReader(in))) {
+                String name = this.file.getName();
+                String line1 = "";
+                String line2 = "";
+
+                ZipEntry packTxtEntry = this.zipFile.getEntry("pack.txt");
+                if (packTxtEntry != null) {
+                    try (InputStream in = this.zipFile.getInputStream(packTxtEntry); BufferedReader br = new BufferedReader(new InputStreamReader(in))) {
                         line1 = br.readLine();
                         line2 = br.readLine();
                     } catch (Exception e) {
-                        LOGGER.error("Exception reading pack.txt for '{}'!", packId, e);
+                        LOGGER.error("Exception reading pack.txt for '{}'!", this.packId, e);
                     }
-				}
-				
-				this.manifest = new ManifestFallback(name, line1, line2, 0);
-			}
-		} else if (file.isDirectory()) {
-			File manifestFile = new File(this.file, "manifest.json");
-			if(manifestFile.exists()) {
+                }
+
+                this.manifest = new ManifestFallback(name, line1, line2, 0);
+            }
+        } else if (this.file.isDirectory()) {
+            File manifestFile = new File(this.file, "manifest.json");
+            if (manifestFile.exists()) {
                 try (InputStream in = Files.newInputStream(manifestFile.toPath())) {
                     readManifest(in);
                 } catch (Exception e) {
-                    LOGGER.error("Exception reading manifest for '{}'!", packId, e);
+                    LOGGER.error("Exception reading manifest for '{}'!", this.packId, e);
                 }
-			}else {
-				// Assume its an old texture pack
+            } else {
+                // Assume its an old texture pack
+
+                String name = this.file.getName();
+                String line1 = "";
+                String line2 = "";
 
-				String name = file.getName();
-				String line1 = "";
-				String line2 = "";
-				
-				File packTxtFile = new File(this.file, "pack.txt");
-				if(packTxtFile.exists()) {
+                File packTxtFile = new File(this.file, "pack.txt");
+                if (packTxtFile.exists()) {
                     try (InputStream in = Files.newInputStream(packTxtFile.toPath()); BufferedReader br = new BufferedReader(new InputStreamReader(in))) {
                         line1 = br.readLine();
                         line2 = br.readLine();
                     } catch (Exception e) {
-                        LOGGER.error("Exception reading pack.txt for '{}'!", packId, e);
+                        LOGGER.error("Exception reading pack.txt for '{}'!", this.packId, e);
                     }
-				}
-				
-				this.manifest = new ManifestFallback(name, line1, line2, 0);
-			}
-		}
-		try {
-			InputStream inputstream = getResourceAsStream("pack.png");
+                }
+
+                this.manifest = new ManifestFallback(name, line1, line2, 0);
+            }
+        }
+        try {
+            InputStream inputstream = getResourceAsStream("pack.png");
+
+            try {
+                this.thumbnailBuffer = ImageIO.read(inputstream);
+            } catch (Throwable var8) {
+                try {
+                    inputstream.close();
+                } catch (Throwable var6) {
+                    var8.addSuppressed(var6);
+                }
 
-			try {
-				this.thumbnailBuffer = ImageIO.read(inputstream);
-			} catch (Throwable var8) {
-				try {
-					inputstream.close();
-				} catch (Throwable var6) {
-					var8.addSuppressed(var6);
-				}
+                throw var8;
+            }
 
-				throw var8;
-			}
+            inputstream.close();
+        } catch (Exception ignored) {
+        }
+    }
 
-			inputstream.close();
-		} catch (Exception ignored) {
-		}
-	}
-	
-	private void readManifest(InputStream in) {
-		try {
-			this.manifest = new Manifest(file, in);
-		}catch (ManifestException e) {
-			this.manifest = new ManifestFallback(fileName, "Manifest Error: " + e.getMessage(), "", -1);
-			LOGGER.error("Manifest Error!", e);
-		}catch (Exception e) {
-			this.manifest = new ManifestFallback(fileName, "Manifest Error", "", -1);
-			LOGGER.error("Manifest Error!", e);
-		}
-	}
+    private void readManifest(InputStream in) {
+        try {
+            this.manifest = new Manifest(this.file, in);
+        } catch (ManifestException e) {
+            this.manifest = new ManifestFallback(this.fileName, "Manifest Error: " + e.getMessage(), "", -1);
+            LOGGER.error("Manifest Error!", e);
+        } catch (Exception e) {
+            this.manifest = new ManifestFallback(this.fileName, "Manifest Error", "", -1);
+            LOGGER.error("Manifest Error!", e);
+        }
+    }
 
-	@Override
-	public void disposeOfTexturePack(Minecraft minecraft)
-    {
-        if(thumbnailBuffer != null)
-        {
-			thumbnailImage.delete();
-			thumbnailImage = null;
+    @Override
+    public void disposeOfTexturePack(Minecraft minecraft) {
+        if (this.thumbnailBuffer != null) {
+            this.thumbnailImage.delete();
+            this.thumbnailImage = null;
         }
         closeTexturePackFile();
     }
 
     @Override
-	public void bindThumbnailTexture(Minecraft minecraft)
-    {
-        if(thumbnailBuffer != null && thumbnailImage == null)
-        {
-            thumbnailImage = minecraft.textureManager.loadBufferedTexture(thumbnailBuffer);
+    public void bindThumbnailTexture(Minecraft minecraft) {
+        if (this.thumbnailBuffer != null && this.thumbnailImage == null) {
+            this.thumbnailImage = minecraft.textureManager.loadBufferedTexture(this.thumbnailBuffer);
         }
-        if(thumbnailBuffer != null)
-        {
-            minecraft.textureManager.bindTexture(thumbnailImage);
-        } else
-        {
-			minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
+        if (this.thumbnailBuffer != null) {
+            minecraft.textureManager.bindTexture(this.thumbnailImage);
+        } else {
+            minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
         }
     }
 
     @Override
-	public void readZipFile()
-    {
-        try
-        {
-            zipFile = new ZipFile(file);
+    public void readZipFile() {
+        try {
+            this.zipFile = new ZipFile(this.file);
+        } catch (Exception ignored) {
         }
-        catch(Exception ignored) { }
     }
 
     @Override
-	public void closeTexturePackFile()
-    {
-        try
-        {
-            zipFile.close();
+    public void closeTexturePackFile() {
+        try {
+            this.zipFile.close();
+        } catch (Exception ignored) {
         }
-        catch(Exception ignored) { }
-        zipFile = null;
+        this.zipFile = null;
     }
 
     @Override
-	public InputStream getResourceAsStream(String path)
-    {
-    	return getResourceAsStream(path, true);
-	}
-	private InputStream getResourceAsStream(String path, boolean firstCall)
-	{
-		if (firstCall && Holidays.getCurrentThemedHoliday() != null && Minecraft.getMinecraft().gameSettings.enableHolidayTextures.value) {
-			assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
-			String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + path).replace("//", "/");
-			InputStream holidayStream = getResourceAsStream(holidayPath, false);
-			if (holidayStream != null) return holidayStream;
-		}
+    public InputStream getResourceAsStream(String path) {
+        return getResourceAsStream(path, true);
+    }
 
-		if (file.isFile())
-		{
-			String zipEntryPath = path;
-			if (path.startsWith("/")) zipEntryPath = path.substring(1);
-			try
-			{
-				java.util.zip.ZipEntry zipentry = zipFile.getEntry(zipEntryPath);
-				if(zipentry != null)
-				{
-					return zipFile.getInputStream(zipentry);
-				}
-			}
-			catch(Exception ignored)
-			{
-				return null;
-			}
-		}
-		else
-		{
-			try
-			{
-				File file = new File(this.file, path);
-				if (file.exists())
-				{
-					return Files.newInputStream(file.toPath());
-				}
-			}
-			catch (Exception ignored)
-			{
-				return null;
-			}
-		}
+    private InputStream getResourceAsStream(String path, boolean firstCall) {
+        if (firstCall && Holidays.getCurrentThemedHoliday() != null && GameSettings.ENABLE_HOLIDAY_TEXTURES.value) {
+            assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
+            String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + path).replace("//", "/");
+            InputStream holidayStream = getResourceAsStream(holidayPath, false);
+            if (holidayStream != null) return holidayStream;
+        }
 
-		return null;
-	}
+        if (this.file.isFile()) {
+            String zipEntryPath = path;
+            if (path.startsWith("/")) zipEntryPath = path.substring(1);
+            try {
+                java.util.zip.ZipEntry zipentry = this.zipFile.getEntry(zipEntryPath);
+                if (zipentry != null) {
+                    return this.zipFile.getInputStream(zipentry);
+                }
+            } catch (Exception ignored) {
+                return null;
+            }
+        } else {
+            try {
+                File file = new File(this.file, path);
+                if (file.exists()) {
+                    return Files.newInputStream(file.toPath());
+                }
+            } catch (Exception ignored) {
+                return null;
+            }
+        }
 
-	@Override
-	protected String[] getFilesInDirectory(String directory)
-	{
-		if (!directory.endsWith("/")) directory = directory + "/";
-		if (file.isFile())
-		{
-			ZipEntry dirEntry = zipFile.getEntry(directory);
-			if (dirEntry != null)
-			{
-				if (dirEntry.isDirectory())
-				{
-					List<String> files = new ArrayList<>();
-					Enumeration<? extends ZipEntry> e = zipFile.entries();
-					while (e.hasMoreElements())
-					{
-						ZipEntry entry = e.nextElement();
-						if (entry.getName().startsWith(directory))
-						{
-							files.add(entry.getName());
-						}
-					}
+        return null;
+    }
 
-					return files.toArray(new String[0]);
-				}
-				else return new String[] { directory };
-			}
-			else return super.getFilesInDirectory(directory);
-		}
-		else
-		{
-			File file = new File(this.file, directory);
-			if (file.exists())
-			{
-				if (file.isDirectory())
-				{
-					File[] files = file.listFiles();
-					if (files != null)
-					{
-						String[] fileStrings = new String[files.length];
-						for (int i = 0; i < files.length; i++)
-						{
-							fileStrings[i] = directory + files[i].getName();
-						}
+    @Override
+    protected String[] getFilesInDirectory(String directory) {
+        if (!directory.endsWith("/")) directory = directory + "/";
+        if (this.file.isFile()) {
+            ZipEntry dirEntry = this.zipFile.getEntry(directory);
+            if (dirEntry != null) {
+                if (dirEntry.isDirectory()) {
+                    List<String> files = new ArrayList<>();
+                    Enumeration<? extends ZipEntry> e = this.zipFile.entries();
+                    while (e.hasMoreElements()) {
+                        ZipEntry entry = e.nextElement();
+                        if (entry.getName().startsWith(directory)) {
+                            files.add(entry.getName());
+                        }
+                    }
 
-						return fileStrings;
-					}
-					else
-					{
-						return new String[0];
-					}
-				}
-				else return new String[] { directory };
-			}
-			else return super.getFilesInDirectory(directory);
-		}
-	}
+                    return files.toArray(new String[0]);
+                } else return new String[]{directory};
+            } else return super.getFilesInDirectory(directory);
+        } else {
+            File file = new File(this.file, directory);
+            if (file.exists()) {
+                if (file.isDirectory()) {
+                    File[] files = file.listFiles();
+                    if (files != null) {
+                        String[] fileStrings = new String[files.length];
+                        for (int i = 0; i < files.length; i++) {
+                            fileStrings[i] = directory + files[i].getName();
+                        }
 
-	@Override
-	public boolean hasFile(String file)
-	{
-		if(this.file.isFile())
-		{
-			boolean h = false;
-			try (ZipFile zipfile = new ZipFile(this.file))
-			{
-				h = zipfile.getEntry(file.substring(1)) != null;
-			}
-			catch (IOException ignored)
-			{
-			}
-			return h;
-		}
-		else
-		{
-			return new File(this.file, file).exists();
-		}
-	}
+                        return fileStrings;
+                    } else {
+                        return new String[0];
+                    }
+                } else return new String[]{directory};
+            } else return super.getFilesInDirectory(directory);
+        }
+    }
+
+    @Override
+    public boolean hasFile(String file) {
+        if (this.file.isFile()) {
+            boolean h = false;
+            try (ZipFile zipfile = new ZipFile(this.file)) {
+                h = zipfile.getEntry(file.substring(1)) != null;
+            } catch (IOException ignored) {
+            }
+            return h;
+        } else {
+            return new File(this.file, file).exists();
+        }
+    }
 }
